---------------------------------------------------------------------
-- Beispielskript zur AEK 20 im Oktober 2017 in Nrnberg und Hannover
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung
---------------------------------------------------------------------

-- Datenbank-ID ermitteln
SELECT DB_ID('AEK20') AS DatenbankID;

-- Aktive Prozesse einer Datenbank ausgeben
SELECT	spid, blocked, cmd, lastwaittype, waitresource, status, sql_handle, 
		dbid, hostname, program_name, nt_domain, nt_username, loginame
FROM	sys.sysprocesses 
WHERE	dbid = DB_ID('AEK20');

-- SQL-Anweisung ausgeben
SELECT * FROM sys.dm_exec_sql_text(0x01000B002B98DE0EE099984AA402000000000000);

-- Aktive Sperren anzeigen
SELECT
		request_session_id, 
		request_mode, request_type, request_status,
		resource_type, resource_database_id,
		resource_description, request_owner_type
FROM
		sys.dm_tran_locks 
WHERE	
		resource_database_id = DB_ID('AEK20')
		AND
		resource_type != 'Database'
ORDER BY
		request_session_id, request_mode;
		
-- Daten der vorherigen Anweisungen ausgeben
SELECT	
		spid as SessionID, blocked as BlockiertVonSessionID,
		lastwaittype as Wartetyp, 
		CASE WHEN resource_type = 'PAGE' THEN resource_description ELSE '' END As Ressource, 
		resource_type As Typ,
		cmd As SqlBefehl, request_mode As Sperrtyp, request_status As Sperrstatus,
		s.[text] as SqlAnweisung, p.[status] As Ausfuehrungstatus, 
		db_name(p.dbid) as Datenbank, hostname As Client, program_name As Applikation, 
		nt_domain As Domain, nt_username As Benutzerkonto, loginame As Anmeldung, *
FROM	
		sys.sysprocesses p
		INNER JOIN	sys.dm_tran_locks t
					ON p.spid = t.request_session_id
		CROSS APPLY sys.dm_exec_sql_text(p.sql_handle) s
WHERE	
		p.spid != @@SPID 
		AND
		p.dbid = DB_ID('AEK20')
		AND
		cmd != 'AWAITING COMMAND'
ORDER BY
		SPID, 
		CASE WHEN resource_type = 'DATABASE' THEN 1
			 WHEN resource_type = 'OBJECT' THEN 2
			 WHEN resource_type = 'PAGE' THEN 3
			 ELSE 4
		END, Sperrtyp;

-- Ausgabe einer Datenseite ermglichen
DBCC TRACEON (3604);

-- Inhalt einer Datenseite ausgeben
DBCC PAGE (AEK20, 1, 1222, 3) WITH TABLERESULTS;